function xx = OMNI_applyinv_HSS_dsym(NODES,EFG,ff)

nboxes = size(NODES,2);

FIELDS = cell(2,nboxes);

% The upwards pass - collect all "outgoing fields".
for ibox = nboxes:(-1):2
  if (NODES{5,ibox}==0) % ibox is a leaf.
    ind = NODES{6,ibox} - 1 + (1:NODES{7,ibox});
    FIELDS{1,ibox} = EFG{2,ibox}*ff(ind,:);
  elseif (NODES{5,ibox}==1) % ibox has precisely one child.
    ison           = NODES{4,ibox}(1);
    FIELDS{1,ibox} = EFG{2,ibox}*FIELDS{1,ison};
  elseif (NODES{5,ibox}==2) % ibox has precisely two children.
    ison1          = NODES{4,ibox}(1);
    ison2          = NODES{4,ibox}(2);
    field_in       = [FIELDS{1,ison1};FIELDS{1,ison2}];
    FIELDS{1,ibox} = EFG{2,ibox}*field_in;
  end
end

% Process the top-level.
f_top = [FIELDS{1,2};FIELDS{1,3}];
x_top = EFG{3,1}*f_top;
FIELDS{2,2} = x_top(1:size(EFG{2,2},1),:);
FIELDS{2,3} = x_top((size(EFG{2,2},1)+1):end,:);

% Downwards pass.
xx = zeros(size(ff));
for ibox = 2:nboxes
  if (NODES{5,ibox}==0) % ibox is a leaf
    ind = NODES{6,ibox} - 1 + (1:NODES{7,ibox});
    xx(ind,:) = EFG{2,ibox}'*FIELDS{2,ibox} + EFG{3,ibox}*ff(ind,:);
  elseif (NODES{5,ibox}==1) % ibox has precisely one child
    ison           = NODES{4,ibox}(1);
    FIELDS{2,ison} = EFG{2,ibox}'*FIELDS{2,ibox} + ...
                     EFG{3,ibox} *FIELDS{1,ison};
  elseif (NODES{5,ibox}==2) % ibox has precisely two children.
    ison1  = NODES{4,ibox}(1);
    ison2  = NODES{4,ibox}(2);
    k1     = NODES{9,ison1};
    k2     = NODES{9,ison2};
    x_long = EFG{2,ibox}'*FIELDS{2,ibox} + EFG{3,ibox}*[FIELDS{1,ison1};FIELDS{1,ison2}];
    FIELDS{2,ison1} = x_long(     (1:k1),:);
    FIELDS{2,ison2} = x_long(k1 + (1:k2),:);
  end
end

return